CipherOutputStream (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.crypto.io

## Class CipherOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - java.io.FilterOutputStream
    - - org.bouncycastle.crypto.io.CipherOutputStream

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable

      public class CipherOutputStream
      extends java.io.FilterOutputStream

  A CipherOutputStream is composed of an OutputStream and a cipher so that write() methods process the written data with the cipher, and the output of the cipher is in turn written to the underlying OutputStream. The cipher must be fully initialized before being used by a CipherInputStream.

  For example, if the cipher is initialized for encryption, the CipherOutputStream will encrypt the data before writing the encrypted data to the underlying stream.

- - ### Field Summary

    - ### Fields inherited from class java.io.FilterOutputStream

      `out`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CipherOutputStream(java.io.OutputStream os, AEADBlockCipher cipher)` Constructs a CipherOutputStream from an OutputStream and a AEADBlockCipher.
    `CipherOutputStream(java.io.OutputStream os, BufferedBlockCipher cipher)` Constructs a CipherOutputStream from an OutputStream and a BufferedBlockCipher.
    `CipherOutputStream(java.io.OutputStream os, StreamCipher cipher)` Constructs a CipherOutputStream from an OutputStream and a BufferedBlockCipher.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes this output stream and releases any system resources associated with this stream.
    `void` | `flush()` Flushes this output stream by forcing any buffered output bytes that have already been processed by the encapsulated cipher object to be written out.
    `void` | `write(byte[] b)` Writes `b.length` bytes from the specified byte array to this output stream.
    `void` | `write(byte[] b, int off, int len)` Writes `len` bytes from the specified byte array starting at offset `off` to this output stream.
    `void` | `write(int b)` Writes the specified byte to this output stream.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CipherOutputStream

          public CipherOutputStream(java.io.OutputStream os,
                                    BufferedBlockCipher cipher)

      Constructs a CipherOutputStream from an OutputStream and a BufferedBlockCipher.

    - #### CipherOutputStream

          public CipherOutputStream(java.io.OutputStream os,
                                    StreamCipher cipher)

      Constructs a CipherOutputStream from an OutputStream and a BufferedBlockCipher.

    - #### CipherOutputStream

          public CipherOutputStream(java.io.OutputStream os,
                                    AEADBlockCipher cipher)

      Constructs a CipherOutputStream from an OutputStream and a AEADBlockCipher.

  - ### Method Detail

    - #### write

          public void write(int b)
                     throws java.io.IOException

      Writes the specified byte to this output stream.
      Overrides:
        `write` in class `java.io.FilterOutputStream`
      Parameters:
        `b` - the `byte`.
      Throws:
        `java.io.IOException` - if an I/O error occurs.

    - #### write

          public void write(byte[] b)
                     throws java.io.IOException

      Writes `b.length` bytes from the specified byte array to this output stream.

      The `write` method of `CipherOutputStream` calls the `write` method of three arguments with the three arguments `b`, `0`, and `b.length`.

      Overrides:
        `write` in class `java.io.FilterOutputStream`
      Parameters:
        `b` - the data.
      Throws:
        `java.io.IOException` - if an I/O error occurs.
      See Also:
        `write(byte[], int, int)`

    - #### write

          public void write(byte[] b,
                            int off,
                            int len)
                     throws java.io.IOException

      Writes `len` bytes from the specified byte array starting at offset `off` to this output stream.
      Overrides:
        `write` in class `java.io.FilterOutputStream`
      Parameters:
        `b` - the data.
        `off` - the start offset in the data.
        `len` - the number of bytes to write.
      Throws:
        `java.io.IOException` - if an I/O error occurs.

    - #### flush

          public void flush()
                     throws java.io.IOException

      Flushes this output stream by forcing any buffered output bytes that have already been processed by the encapsulated cipher object to be written out.

      Any bytes buffered by the encapsulated cipher and waiting to be processed by it will not be written out. For example, if the encapsulated cipher is a block cipher, and the total number of bytes written using one of the `write` methods is less than the cipher's block size, no bytes will be written out.

      Specified by:
        `flush` in interface `java.io.Flushable`
      Overrides:
        `flush` in class `java.io.FilterOutputStream`
      Throws:
        `java.io.IOException` - if an I/O error occurs.

    - #### close

          public void close()
                     throws java.io.IOException

      Closes this output stream and releases any system resources associated with this stream.

      This method invokes the `doFinal` method of the encapsulated cipher object, which causes any bytes buffered by the encapsulated cipher to be processed. The result is written out by calling the `flush` method of this output stream.

      This method resets the encapsulated cipher object to its initial state and calls the `close` method of the underlying output stream.

      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.FilterOutputStream`
      Throws:
        `java.io.IOException` - if an I/O error occurs.
        `InvalidCipherTextIOException` - if the data written to this stream was invalid ciphertext (e.g. the cipher is an AEAD cipher and the ciphertext tag check fails).